//+------------------------------------------------------------------+
//|                                                 Mn ATR-RAnge.mq4 |
//+------------------------------------------------------------------+
#property copyright "Mn"

#property indicator_chart_window

extern int mAtrPrd = 20,
           mTextSize = 10;
extern color mCol = LimeGreen;
extern ENUM_BASE_CORNER mCorn = CORNER_RIGHT_LOWER;
extern int xPosition = 10;
extern int yPosition = 10;
extern string UniqueID = "ATR-range1";
extern bool   alertsOn      = true;
extern double alertsOnRatio = 1.8;
extern bool   alertsMessage = true;
extern bool   alertsSound   = false;
extern bool   alertsEmail   = false;
extern bool   alertsPush    = false;
extern int barToUse=0;
           
int mPipFact = 1;

//+------------------------------------------------------------------+
int init()
 { 
   ObjectCreate(UniqueID, OBJ_LABEL, 0, 0, 0, 0, 0);
   ObjectSet(UniqueID, OBJPROP_CORNER, mCorn);
   ObjectSet(UniqueID, OBJPROP_XDISTANCE, xPosition);
   ObjectSet(UniqueID, OBJPROP_YDISTANCE, yPosition);
   ObjectSetText(UniqueID, " ", mTextSize, "TimesNewRoman Bold", CLR_NONE);
   
   if(Digits == 3 || Digits == 5)
     mPipFact = 10;

  return(0); 
 }
 
//-----------------------------------------------+ 
int start()
 {
   double mAtr, mRng;
   
   mAtr = iATR(NULL, 0, mAtrPrd, barToUse) / Point / mPipFact;
   mRng = (High[barToUse] - Low[barToUse]) / Point / mPipFact;
   
   ObjectSetText(UniqueID, "ATR " + DoubleToStr(mAtr, 1) + " : Rng " + DoubleToStr(mRng, 1)+" - Current range / ATR = "+DoubleToStr(mRng/mAtr,3), mTextSize, 
                  "Arial Bold", mCol);

      if (alertsOn) if (NormalizeDouble(mRng/mAtr,3) >= alertsOnRatio)   doAlert(0,"ratio "+(string)alertsOnRatio+" exceeded");

  return(0);
 }
 
//-----------------------------------------------+
int deinit()
 {
  ObjectDelete(UniqueID);
  
  return(0);
 }

//-----------------------------------------------+

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

           message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" atr range "+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsPush)    SendNotification(message);
             if (alertsEmail)   SendMail(Symbol()+" "+Period()+" atr ratio",message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}